//
//  QRUController.m
//  QRURL
//
//  Created by 小山 嘉昭 on 12/05/31.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "QRUController.h"
#import "MyView.h"
#import "qrencode.h"

#include <string.h>
#include <errno.h>

/*
    QRコードの(二次元バーコード)仕組み・作成・生成・変換方法ホームページ(HowToMakeQRCode)
    http://www.tech-jp.com/QRCode/
 */

/*
    リンク集 - プチコンまとめWiki
    http://wiki.hosiken.jp/petc/?Link
    PTC2QR
*/

/*
    詳しい関数の解説は、ヘッダファイル qrencode.h を参照
 */

@implementation QRUController

@synthesize myView = _myView;
@synthesize qrURL = _qrURL;

- (id)init
{
    self = [super init];
    if (self) {
        // Add your subclass-specific initialization here.
    }
    return self;
}


/*
 
 */
- (IBAction)doQREncode1:(id)sender {
    QRcode *qrcode = NULL;
    const char *urlChar;

    NSLog(@"QREncode1");

    NSString *url = [self.qrURL stringValue];
    
    if ((url == nil) || ([url isEqualToString:@""] == YES)) {
        url = @"http://kyoshiaki.sakura.ne.jp/osx/index.html";
        [self.qrURL setStringValue:url];
    }
    
    urlChar = [url UTF8String]; 
    
    qrcode = QRcode_encodeString(urlChar, 20, QR_ECLEVEL_H, QR_MODE_KANJI, 1);

    if (self.myView.qrcode != NULL) {
        NSLog(@"Free");
        QRcode_free(self.myView.qrcode);
    }
    self.myView.qrcode = qrcode;
    
    if (qrcode == NULL) {
        NSLog(@"errno");
    }
    
    [self.myView setNeedsDisplay:YES];
}

/*
 
 */
- (void)doQREncode2:(id)sender {
    
    QRinput *input;
    int version;
    unsigned char *data;
    QRcode *qrcode = NULL;
    NSUInteger len;   

    NSLog(@"QREncode2");
    
    NSString *url = [self.qrURL stringValue];
    
    if ((url == nil) || ([url isEqualToString:@""] == YES)) {
        url = @"http://kyoshiaki.sakura.ne.jp/osx/index.html";
        [self.qrURL setStringValue:url];
    }

    len = [url length];
    
    data = (unsigned char *)[url UTF8String];
    
    input = QRinput_new2(20, QR_ECLEVEL_M);
 
    version = QRinput_append(input, QR_MODE_8, (int)len, data);
    
    qrcode = QRcode_encodeInput(input);

    if (self.myView.qrcode != NULL) {
        NSLog(@"Free");
        QRcode_free(self.myView.qrcode);
    }

    self.myView.qrcode = qrcode;
    
    if (qrcode == NULL) {
        NSLog(@"errno");
    }

    [self.myView setNeedsDisplay:YES];
}

@end
